/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function ObmRRemoteAPI() {};

ObmRRemoteAPI.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRRemoteAPI)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

	/*
	 * obmIRRemoteAPI
	 */

	createTaskProxy: function() {
		return Cc["@obm.org/obm-sync-rest/taskproxy;1"].createInstance(Ci.obmIRTaskProxy);
	},
	createAddressBookProxy: function() {
		return Cc["@obm.org/obm-sync-rest/addressbookproxy;1"].createInstance(Ci.obmIRAddressBookProxy);
	},
	createCalendarProxy: function() {
		return Cc["@obm.org/obm-sync-rest/calendarproxy;1"].createInstance(Ci.obmIRCalendarProxy);
	},
	createLoginProxy: function() {
		return Cc["@obm.org/obm-sync-rest/loginproxy;1"].createInstance(Ci.obmIRLoginProxy);
	}
};

// module

var ObmRRemoteAPIModule = {
	mCID: Components.ID("{f4a5a493-4c2c-4919-97bf-95059e4415ab}"),
	mContractID: "@obm.org/obm-sync-rest/service;1",
	registerSelf: function (compMgr, fileSpec, location, type) {
		dump("registerSelf:@obm.org/obm-sync-rest/service;1"+"\n");
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM RemoteAPI Service",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {

		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new ObmRRemoteAPI()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return ObmRRemoteAPIModule;
}

