/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
/*
 * Globals
 */

if (Components.interfaces.nsILoginManager) {
	var gPasswordManager = Components.classes["@mozilla.org/login-manager;1"]
                                .getService(Components.interfaces.nsILoginManager);
} else {
	var gPasswordManager = Components.classes["@mozilla.org/passwordmanager;1"]
								.getService(Components.interfaces.nsIPasswordManager);
}

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
.createInstance(Components.interfaces.mozIJSSubScriptLoader);

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
.getService(Components.interfaces.nsIPromptService);
function log(e) {
	Components.utils.reportError(e);// UtilsOBM.logMessageToConsole(e);
}

/*
 * Scritps
 */
if ( typeof(UtilsOBM) == "undefined" ) {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
}

if ( typeof(calendarDefaultTimezone) == "undefined" ) {
	try {
		scriptLoader.loadSubScript("chrome://calendar/content/calUtils.js");
	} catch(e) {}
}

// Init logger
var gLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var writer = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
gLogger.setLevelWriter(gLogger.LOAD_LEVEL, writer);
gLogger.setHeader("=== extension.js: ");


/*
 * Functions
 */
function OBM_ShowWindow(aName) {
	return window.openDialog(
		"chrome://obm-extension/content/calendar/" + aName,  "",
		"modal,centerscreen,chrome,resizable=no"
	);
}

function OBM_ShowLog() {
  var file = Components.classes["@mozilla.org/file/directory_service;1"].
    getService(Components.interfaces.nsIProperties).
    get("TmpD", Components.interfaces.nsIFile);
  file.QueryInterface(Components.interfaces.nsILocalFile);
  file.append("obm-connector-log.txt");
  try {
    file.launch();
  } catch(e) {
    try {
      var uri = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService).
        newFileURI(file);
      var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].
        getService(Components.interfaces.nsIExternalProtocolService);
      protocolSvc.loadUrl(uri);
    } catch(e) {
      alert(e);
    }
  }
}

function OBM_getTicket(){
	var obmUrl = UtilsOBM.getCharPref("extensions.obm.obmUrl");
	var dealerUrl = obmUrl + "/sso/sso_index.php?action=ticket&mode=interactive";
	var httpRequest = XMLHttpRequest();
	
	var username = {};
	var password = {};
	if ( !UtilsOBM.getOBMCredentials(username, password) || username.value == "" || password.value == "" ) {
		if (username.value == undefined || username.value == "") {
			var title = UtilsOBM.getLocalizedMessage("obmconf");
			var message = UtilsOBM.getLocalizedMessage("obmconfcredentials");
			promptService.alert(window, title, message);

			OBM_ShowWindow("preferences/connection.xul");
			return OBM_getTicket();
		} else {
			// prompt only for password
			OBM_ShowWindow("preferences/password.xul");
			if (UtilsOBM.getTemporaryPassword(password) == false) {
				return null//;OBM_getTicket();
			}
		}
	}

	httpRequest.open('POST', dealerUrl, false);
	httpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	try {
		var params = "login=" + encodeURIComponent( username.value.split("@")[0] )
		+ "&password=" + encodeURIComponent( password.value )
		+ "&domaine=" + encodeURIComponent( username.value.split("@")[1] );
		//dump("params:"+params+"\n");
		httpRequest.send(params);
	} catch (e) {
		throw e;
	}
	var httpResponse = {
		status: httpRequest.status,
		statusText: httpRequest.statusText,
		responseXML: httpRequest.responseText
	};
	//dump("resp:"+httpResponse.responseXML+"\n");
	if (!httpResponse.responseXML.match("ticket=[:print:]*")) {
		throw new Error('noTicket');
	}
	return httpResponse.responseXML;
}

function OBM_OpenLink(aPage) {
	// suppress external-load warning for standard browser schemes
	UtilsOBM.setBoolPref("network.protocol-handler.warn-external.http", false);
	UtilsOBM.setBoolPref("network.protocol-handler.warn-external.https", false);

	var obmUrl = UtilsOBM.getCharPref("extensions.obm.obmUrl", "");
	if (obmUrl == "") {
		var title = UtilsOBM.getLocalizedMessage("obmconf");
		var message = UtilsOBM.getLocalizedMessage("obmconfobmweb");
		promptService.alert(window, title, message);
		OBM_ShowWindow("preferences/connection.xul");
		return OBM_OpenLink(aPage);
	}
	var sso = UtilsOBM.getBoolPref("extensions.obm.sso", false);
	var pageURL = obmUrl;
	switch (aPage) {
		case "obm-web-agenda":
		if (sso) {
			try {
				var ticket = OBM_getTicket();
			} catch (e) {
				if (e.message == 'noTicket') {
					UtilsOBM.showAlert("authenticationfailed");
				} else {
					UtilsOBM.showAlert("connectionfailed");
				}
				return null;
			}
			if (!ticket) {
				return null;
			}
			pageURL += "/calendar/calendar_index.php?auth_ticket=" + ticket.split("=")[1];
		}      
		break;
		default:
		return null;
	}
	var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uriToOpen = ioservice.newURI(pageURL, null, null);
	var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
	// now, open it!
	extps.loadURI(uriToOpen, null);
	return null;
}

function OBM_Synchronize() {
	
	try {
		var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
		var username = {};
		var password = {};
		if ( !UtilsOBM.getOBMCredentials(username, password)
		|| username.value == "" || password.value == ""
		|| UtilsOBM.getCharPref("extensions.obm.server", "") == "" ) {
			if (username.value == undefined || username.value == ""
			|| UtilsOBM.getCharPref("extensions.obm.server", "") == "") {
				var title = UtilsOBM.getLocalizedMessage("obmconf");
				var message = UtilsOBM.getLocalizedMessage("obmconfsyncserver");
				promptService.alert(window, title, message);

				OBM_ShowWindow("preferences/connection.xul");
				if (globalData.cancel) return;
				return OBM_Synchronize();
			} else {
				// prompt only for password
				OBM_ShowWindow("preferences/password.xul");
				if (globalData.cancel) return;
				if (UtilsOBM.getTemporaryPassword(password) == false)
					return OBM_Synchronize();
			}
		}
		
		var wWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);

		var params = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		/*
		 * var description =
		 * Components.classes["@mozilla.org/supports-string;1"]
		 * .createInstance(Components.interfaces.nsISupportsString);
		 * description.data = "Agenda \"" + this.name + "\"";
		 * params.AppendElement(description); params.AppendElement(this);
		 */
		var window = wWatcher.getWindowByName("OBM_SYNCHRO", null)
		if (window == null){
			UtilsOBM.logToFile("synchronization window does not exist" + "\n");

			window = wWatcher.openWindow(
				null,
				"chrome://obm-extension/content/calendar/sync-dialog.xul",
				"OBM_SYNCHRO",
				"modal,centerscreen,chrome,resizable=no,dialog",
				params
			);

		} else {
			UtilsOBM.logToFile("synchronization window already exist" + "\n");
		}
	} catch (e) {
		gLogger.error(e, true, false);
	}
	return null;
}

/* Connection Window */

function OBM_LoadConnectionSettings() {
	document.getElementById("syncLocation").value = UtilsOBM.getCharPref("extensions.obm.server", "");
	document.getElementById("webLocation").value = UtilsOBM.getCharPref("extensions.obm.obmUrl", "");
	var username = {};
	var password = {};
	if ( UtilsOBM.getOBMCredentials(username, password) ) {
		document.getElementById("username").value = username.value;
		document.getElementById("password").value = password.value;
	}
	document.getElementById("savepassword").checked = UtilsOBM.getBoolPref("extensions.obm.rememberpassword", true);
}
function OBM_LoadPasswordSettings() {
	var username = {};
	var password = {};
	if ( UtilsOBM.getOBMCredentials(username, password) ) {
		document.getElementById("password").value = password.value;
	}
	document.getElementById("savepassword").checked = UtilsOBM.getBoolPref("extensions.obm.rememberpassword", true);
}

function OBM_SaveConnectionSettings(cancel) {
	try {
		var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
		if (cancel) {
			globalData.cancel = true;
			return;
		} else {
			globalData.cancel = false;
		}
		
		UtilsOBM.setCharPref("extensions.obm.server", document.getElementById("syncLocation").value);
		UtilsOBM.setCharPref("extensions.obm.obmUrl", document.getElementById("webLocation").value);
	
		UtilsOBM.setBoolPref("extensions.obm.rememberpassword",
		document.getElementById("savepassword").checked);
		if (document.getElementById("savepassword").checked){
			UtilsOBM.setOBMCredentials(document.getElementById("username").value,
			document.getElementById("password").value);
		} else {
			UtilsOBM.setOBMCredentials(document.getElementById("username").value, "");
			UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
		}
	} catch (e) {
		gLogger.error(e,true,false);
	}
}

function OBM_SavePasswordSettings(cancel) {
	var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
	if (cancel) {
		globalData.cancel = true;
		return;
	} else {
		globalData.cancel = false;
	}
	UtilsOBM.setBoolPref("extensions.obm.rememberpassword",
		document.getElementById("savepassword").checked);
	if (document.getElementById("savepassword").checked){
		var username = {};
		var password = {};
		if (UtilsOBM.getOBMCredentials(username, password)){    
			UtilsOBM.setOBMCredentials(username.value,
			document.getElementById("password").value);
		} else {
			UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
		}
	} else {
		UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
	}
}

/* Synchronization Window */

function OBM_LoadSynchronizationSettings() {
  document.getElementById("override").value = UtilsOBM.getCharPref("extensions.obm.override", "");
  document.getElementById("contactRefresh").value = UtilsOBM.getIntPref("extensions.obm.contact.autorefresh.timeout", "");
  if (UtilsOBM.getBoolPref("calendar.autorefresh.enabled", false)) {
    document.getElementById("calendarRefresh").value = UtilsOBM.getIntPref("calendar.autorefresh.timeout", "");
  } else {
    document.getElementById("calendarRefresh").value = "";
  }
  document.getElementById("calendarRefresh").value = UtilsOBM.getIntPref("calendar.autorefresh.timeout", "");
  document.getElementById("syncOnStart").checked = UtilsOBM.getBoolPref("extensions.obm.syncOnStart", false);
  document.getElementById("syncOnQuit").checked = UtilsOBM.getBoolPref("extensions.obm.syncOnQuit", false);
}

function OBM_SaveSynchronizationSettings() {
  UtilsOBM.setCharPref("extensions.obm.override", document.getElementById("override").value);
  UtilsOBM.setIntPref("extensions.obm.contact.autorefresh.timeout", document.getElementById("contactRefresh").value);
  var crefresh = document.getElementById("calendarRefresh").value;
  UtilsOBM.setIntPref("calendar.autorefresh.timeout", crefresh);
  if (crefresh == "" || crefresh == 0) {
    UtilsOBM.setBoolPref("calendar.autorefresh.enabled",false);
  } else {
    UtilsOBM.setBoolPref("calendar.autorefresh.enabled",true);
  }
  UtilsOBM.setBoolPref("extensions.obm.syncOnStart", document.getElementById("syncOnStart").checked);
  UtilsOBM.setBoolPref("extensions.obm.syncOnQuit", document.getElementById("syncOnQuit").checked);
}

function OBM_GetAddressBookNames() {
  var names = UtilsOBM.getCharPref("extensions.obm.addressbooks", null);
  return names ? names.split(",") : [];
}

/* Reset Button */
function OBM_Reset() {
	// disable synchronization on start and quit
	var syncOnQuit = UtilsOBM.getBoolPref("extensions.obm.syncOnQuit", false);
	UtilsOBM.setBoolPref("extensions.obm.syncOnQuit.beforeReset", syncOnQuit);
	UtilsOBM.setBoolPref("extensions.obm.syncOnQuit", false);
	
	var syncOnStart = UtilsOBM.getBoolPref("extensions.obm.syncOnStart", false);
	UtilsOBM.setBoolPref("extensions.obm.syncOnStart.beforeReset", syncOnStart);
	UtilsOBM.setBoolPref("extensions.obm.syncOnStart", false);
	// unsubscribe from all OBM calendars

	var calendarManager = UtilsOBM.getCalendarManager();

	var calendars = calendarManager.getCalendars({});
	for each ( var calendar in calendars ) {
		if ( calendar.type == "obm" ) {
			// both have to be called
			calendarManager.unregisterCalendar(calendar);
			calendarManager.deleteCalendar(calendar);
		}
	}
	
	// Reset des categories
	var currentCategories = getLocalizedPref("calendar.categories.names");
	if (currentCategories && currentCategories != "") {
	  currentCategories = currentCategories.split(",");
	} else {
	  currentCategories = [];
	}
  
	var resetCategories = [];
	
	for each (var category in currentCategories) {
	  if ( !category.match("[OBM]")) {
		  resetCategories.push(category);
	  }
	}
	setLocalizedPref("calendar.categories.names", resetCategories.join(","));
	

	// delete OBM address books
	
	if ("@mozilla.org/abmanager;1" in Components.classes) {
		var addressBookManager = Components.classes["@mozilla.org/abmanager;1"]
             .getService(Components.interfaces.nsIAbManager);
		var abNames = UtilsOBM.getCharPref("extensions.obm.addressbooks", null);
		abNames = abNames ? abNames.split(",") : [];
		for each(var abName in abNames) {
			var dirPrefId = "ldap_2.servers." + abName;//UtilsOBM.getCharPref("extensions.obm.addressbooks." + abName);
			var iter = addressBookManager.directories;
			while (iter.hasMoreElements()) {
			  var data = iter.getNext();
			  if (data instanceof Components.interfaces.nsIAbDirectory) {
				if (data.dirPrefId == dirPrefId) {
					addressBookManager.deleteAddressBook(data.URI);
				}
			  }
			}
		}
		
	} else {
		
		var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var addressBookService = Components.classes["@mozilla.org/addressbook;1"].getService(Components.interfaces.nsIAddressBook);
	
		var datasource = Components.classes["@mozilla.org/rdf/datasource;1?name=addressdirectory"].getService(Components.interfaces.nsIRDFDataSource);
	
		var parentArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		parentArray.AppendElement(rdfService.GetResource("moz-abdirectory://"));
	
		for each ( var addressBookName in OBM_GetAddressBookNames() ) {
			var abURI = "moz-abmdbdirectory://alia-obm-" + addressBookName + ".mab";
			var directoryResource = rdfService.GetResource(abURI);
			if ( directoryResource ) {
				var resourceArray = Components.classes["@mozilla.org/supports-array;1"]
				.createInstance(Components.interfaces.nsISupportsArray);
				resourceArray.AppendElement(directoryResource);
				addressBookService.deleteAddressBooks(datasource, parentArray, resourceArray);
			}
		}
		
	}
	
	

	// delete prefs
	UtilsOBM.deletePreferenceBranch("extensions.obm.changes");
	UtilsOBM.deletePreferenceBranch("extensions.obm.lastPurgeAsk");
	
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

	// restart now
	var check = {value: false};
	var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;

	var title = UtilsOBM.getLocalizedMessage("obmreinittitle");
	var message = UtilsOBM.getLocalizedMessage("obmreinitmessage");
	var rightnow = UtilsOBM.getLocalizedMessage("obmreinitrightnow");
	var later = UtilsOBM.getLocalizedMessage("obmreinitlater");
	var button = promptService.confirmEx(window, title,
	message, flags, rightnow , later, "", null, check);
	

	if (button == 0) {
		// restart now
		var nsIAppStartup = Components.interfaces.nsIAppStartup;
		Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup).quit(nsIAppStartup.eForceQuit | nsIAppStartup.eRestart);   
	}
}

function OBM_ImportCalendars() {
	var calendarManager = UtilsOBM.getCalendarManager();

	var calendars = calendarManager.getCalendars({});
	for each ( var calendar in calendars ) {
		if ( calendar.type == "obm" ) {
			UtilsOBM.importCalendar(calendar);
		}
	}
}

function OBM_Purge() {
	var preff = UtilsOBM.getBoolPref("extensions.obm.calEvents.is_sync_enabled");
	if (preff) {
	  //ask for purge on personnal calendar
	  var username = {};
	  var password = {};
	  if (!UtilsOBM.getOBMCredentials(username, password) || username.value == "") {
		//nothing
	  } else {
		var calendarManager = UtilsOBM.getCalendarManager();
		var calendars = calendarManager.getCalendars({});
		for each(var calendar in calendars) {
		  if (calendar.type == "obm") {
			var calName = calendarManager.getCalendarPref_(calendar, "X-OBM-NAME");
			if (calName == username.value.split("@")[0]) {
			  UtilsOBM.purgeCalendar(calendar);
			  break;
			}
		  }
		}
	  }
	}
}