/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const HTML_NS = "http://www.w3.org/1999/xhtml";
const Cc = Components.classes;
const Ci = Components.interfaces;

var gSearchInput;

if ( typeof(UtilsOBM) == "undefined" ) {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
}

function GenericWrappedXPComObject() {
	this.wrappedJSObject = this;
};
GenericWrappedXPComObject.prototype.QueryInterface = function(aIID) {
	if (!aIID.equals(Ci.nsISupports)) {
		throw Cr.NS_ERROR_NO_INTERFACE;
	}
	return this;
};

function displayError(aMessage) {
	var loading = document.getElementById('loading');
	loading.removeChild(loading.firstChild);
	var result = document.getElementById('loading.label');
	result.setAttribute("value",aMessage);
	this.error = true;
}


function fillSubscriptions(aCalendarsArray) {
	var loading= document.getElementById('loading');
	var tree = document.getElementById('calendars-tree');
	loading.setAttribute("hidden","true");
	tree.setAttribute("hidden","false");
	
	var treeChildren = document.getElementById('calendars-treechildren');
	UtilsOBM.emptyDOMNode(treeChildren);
	
	var calendars = aCalendarsArray.QueryInterface(Ci.nsIArray);
	var count = calendars.length;
	
	default xml namespace = new Namespace("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
	
	for (var i = 0; i < count; i++) {
		if (UtilsOBM.getBoolPref("extensions.obm.rest", false)) {
			var calInfo = calendars.queryElementAt(i, Ci.obmIRCalendarInfo);
		} else {
			var calInfo = calendars.queryElementAt(i, Ci.obmICalendarInfo);
		}
		
		var subs = false;
		if (_isSubscribed(calInfo.uid)) subs = true;
		
		var treeItem =
		  <treeitem>
			<treerow id={ "_" + calInfo.uid }>
			  <treecell properties={ !calInfo.write ?"readOnly":"readWrite" }/>
			  <treecell label={ calInfo.firstname + " " + calInfo.lastname }/>
			  <treecell label={ calInfo.mail }/>
			  <treecell value={ subs }/>
			</treerow>
		  </treeitem>;
		
		UtilsOBM.appendE4XChildToNode(treeChildren, treeItem);
	}
}

function _isSubscribed(aCalInfoUid) {
	var calMgr = Cc["@mozilla.org/calendar/manager;1"].getService(Ci.calICalendarManager);
	var calendars = calMgr.getCalendars({});
	for each(var calendar in calendars) {
		if (calendar.type == "obm" && calMgr.getCalendarPref_(calendar, "X-OBM-NAME") == aCalInfoUid) {
			return calendar;
		}
	}
	return null;
}

function _subscribeToCalendar(aUid, aName, aEmail, aReadOnly) {
	//this.logger.debug("_subscribeToCalendar(" + aUid + ")", false, false);
	//this.callerListener.onNewOperation("subscribingToCal");
	
	var uid = aUid;
	//var name = UtilsOBM.getCharPref("extensions.obm.autoconf.calname", null);
	//if (!name) {
		var name = "[OBM] " + aName;
	//}
	var email = aEmail;
	var color = UtilsOBM.getRandomColor();
	var readonly = aReadOnly;
	dump("_subscribeTo: " + uid + ", " + name + ", " +  email + ", " + color + ", " + readonly + "\n");
	
	var calMgr = Cc["@mozilla.org/calendar/manager;1"].getService(Ci.calICalendarManager);
	UtilsOBM.setBoolPref(
	  "extensions.obm.changes.calICalendar."
	  + uid
	  + ".readOnly", readonly
	);
	
	
	var uri = Cc["@mozilla.org/network/simple-uri;1"].createInstance(Ci.nsIURI);
	uri.spec = "moz-profile-calendar://?id=" + UtilsOBM.getNextLocalCalendarID() + ";" + uid;
	//this.logger.debug("uri.spec: " + uri.spec, false, false);
	var newCalendar = calMgr.createCalendar("obm", uri);
	calMgr.registerCalendar(newCalendar);
	newCalendar.name = name;
	calMgr.setCalendarPref_(newCalendar, "X-OBM-NAME", uid.toString()); 
	calMgr.setCalendarPref_(newCalendar, 'X-OBM-EMAIL', email.toString());
	newCalendar.setProperty("color", color.toString());
	
	UtilsOBM.setCharPref("extensions.obm.changes."
			+ Ci.calICalendar + "."
			+ uid + "."
			+ "lastSync",
			"1970-01-01T00:00:00Z");
			
}

function _updateCalendar(aCalendar, aUid, aName, aEmail, aReadOnly) {
	//this.logger.debug("_updateToCalendar(" + aUid + ")", false, false);
	//this.callerListener.onNewOperation("subscribingToCal");
	
	var uid = aUid;
	//var name = UtilsOBM.getCharPref("extensions.obm.autoconf.calname", null);
	//if (!name) {
		var name = "[OBM] " + aName;
	//}
	var email = aEmail;
	var readonly = aReadOnly;
	dump("_updateCalendar: " + uid + ", " + name + ", " +  email + ", " + readonly + "\n");
	
	var calMgr = Cc["@mozilla.org/calendar/manager;1"].getService(Ci.calICalendarManager);
	UtilsOBM.setBoolPref(
	  "extensions.obm.changes.calICalendar."
	  + uid
	  + ".readOnly", readonly
	);
	
	aCalendar.name = name;
	calMgr.setCalendarPref_(aCalendar, "X-OBM-NAME", uid.toString()); 
	calMgr.setCalendarPref_(aCalendar, 'X-OBM-EMAIL', email.toString());	
}

function saveSubscriptionSettings() {
	if (this.error)
		return;
	
	var treeChildren = document.getElementById('calendars-treechildren');

	var xmlCalendarsList = UtilsOBM.DOMElementToE4X(treeChildren);

	var checkedCalendars = new HashMap();

	for each ( var treeRow in xmlCalendarsList..*::treerow ) {
		// subscribed ?
		if ( treeRow.*::treecell[3].@value == "true" ) {
			checkedCalendars.put(treeRow.@id.substring(1), treeRow); // remove
			// '_'
			// treerow
			// @id
			// prefix;
		}
	}

	var calMgr = Cc["@mozilla.org/calendar/manager;1"].getService(Ci.calICalendarManager);
	var currentlySubscribed = calMgr.getCalendars({});

	// unsubscribe from non-checked calendars
	for each ( var calendar in currentlySubscribed ) {  
		// dump("subscribed calendar: type = " + calendar.type + ", name = " +
		// calendar.name + "\n");
		var uri = calendar.uri.spec;
		if ( calendar.type == "obm"
		&& !checkedCalendars.containsKey(uri.substring(uri.indexOf(";") + 1)) ) {
			// both have to be called
			calMgr.unregisterCalendar(calendar);
			calMgr.deleteCalendar(calendar);
		}
	}

	// addd checked calendars
	for each ( var checkedCalendarUID in checkedCalendars.keySet() ) {

		var checkedCalendarTreeRow = checkedCalendars.get(checkedCalendarUID);

		var calendarName = checkedCalendarTreeRow.*::treecell[1].@label;
		// e-mail of the calendar owner, used for attendee checking
		var email = checkedCalendarTreeRow.*::treecell[2].@label;
		var color = UtilsOBM.getRandomColor();
		var readOnly = checkedCalendarTreeRow.*::treecell[0].@properties == "readOnly";
		
		var cal = _isSubscribed(checkedCalendarUID);
		if ( cal ) {
			// update infos
			_updateCalendar(cal, checkedCalendarUID, calendarName, email, readOnly);
		} else {
			_subscribeToCalendar(checkedCalendarUID, calendarName, email, readOnly);
		}
		
	}
}

function setupSearchInput() {
  if ( !gSearchInput ) {
    gSearchInput = document.getElementById("searchInputt");
  }
  document.getElementById("calendars-tree").focus();
}

function onSearchInputFocus()
{
  gSearchInput.select();
}

function onSearchInputBlur()
{
}

function onSearchKeyPress(aEvent) {
  
}

/*
var gQuickSearchFocusEl = null; 
*/
function onClearSearch()
{
  if (gSearchInput && !gSearchInput.showingSearchCriteria) // ignore the text box value if it's just showing the search criteria string
  {
     gSearchInput.value = "";
     updateCalendarList();
     // this needs to be on a timer otherwise we end up messing up the focus while the Search("") is still happening
     setTimeout("restoreSearchFocusAfterClear();", 0); 
  }
}

function restoreSearchFocusAfterClear()
{
  gSearchInput.clearButtonHidden = 'true';
  //gQuickSearchFocusEl = null;
}

function updateCalendarList() {
  var treeItems = document.getElementsByTagName("treeitem");
  for ( var i = 0; i < treeItems.length; i++ ) {
    var treeItem = treeItems.item(i);
    var treeCells = treeItem.getElementsByTagName("treecell");    
    var displayName = treeCells.item(1).getAttribute("label"); // second cell
    var search = gSearchInput.value.toLowerCase();
    if ( search == "" ) {
      treeItem.setAttribute("hidden", "false");
    } else if ( displayName.toLowerCase().indexOf(gSearchInput.value) == -1 ) {
      treeItem.setAttribute("hidden", "true");
    } else {
	  treeItem.setAttribute("hidden", "false");
	}
  }
}

function SyncObserver() {
}
SyncObserver.prototype = {
	observe: function(subject, topic, data) {
		switch(data) {
			case "newOperation":
				break;
			case "operationDone":
				this.lastData = subject.wrappedJSObject.opResData;
				break;
			case "newOperationSet":
				break;
			case "operationSetError":
				var msg = subject.wrappedJSObject.message;
				displayError(msg);
				this.unregister();
				break;
			case "operationSetDone":
				break;
			case "allDone":
				fillSubscriptions(this.lastData);
				this.unregister();
				break;
			default:
		}
	},
	register: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, "subscribe-obm-sync", false);
	},
	unregister: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this, "subscribe-obm-sync");
	}
}

function listAllOBMCalendars() {
	var ObserverServ = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

	var useRest = UtilsOBM.getBoolPref("extensions.obm.rest", false);
	if (useRest) {
		var calSync = Components.classes["@obm.org/obm-sync-rest/calendarsync;1"].createInstance(Components.interfaces.obmIRCalendarSync);
	} else {
		var calSync = Components.classes["@obm.org/obm-sync/calendarsync;1"].createInstance(Components.interfaces.obmICalendarSync);
	}
	
	var opIdx = 0;
	var operations = [];
	
	operations[0] = ["Calendar", function(arg){calSync.getSubscribleCalendars(arg)}];

	var listener = {
		onStart: function() {
		},

		onNewOperation: function(aOpName) {
			var msg = new GenericWrappedXPComObject();
			msg.opName = aOpName;
			ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "newOperation");
		},
		onOperationDone: function(aSuccess, aResultData) {
			var msg = new GenericWrappedXPComObject();
			msg.opRes = aSuccess;
			msg.opResData = aResultData;
			ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "operationDone");
		},
		onProgress: function(aIdx, aTotal, aType) {
			/*var msg = new GenericWrappedXPComObject();
			msg.idx = aIdx;
			msg.total = aTotal;
			msg.type = aType;
			ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "operationProgress");*/
		},
		onError: function(aMessage) {
			dump("EXCEPTION: " + aMessage + "\n");
			var msg = new GenericWrappedXPComObject();
			msg.message = aMessage;
			ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "operationSetError");
		},
		onStop: function(aRes, aMessage) {
			var msg = new GenericWrappedXPComObject();
			msg.message = aMessage;
			if (aRes == Components.results.NS_OK) {
				ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "operationSetDone");
				this.nextOperation();
			} else {
				ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "operationSetError");
			}
		},
		nextOperation: function() {
			if (opIdx >= operations.length) {
				ObserverServ.notifyObservers(null, "subscribe-obm-sync", "allDone");
				return;
			}

			var msg = new GenericWrappedXPComObject();
			msg.opSetName = operations[opIdx][0];
			ObserverServ.notifyObservers(msg, "subscribe-obm-sync", "newOperationSet");
			try {
				operations[opIdx++][1](this);
			} catch(e) {
				listener.onError(e);
			}
		}
	};
	listener.nextOperation();
}

function onLoad() {
	var obs = new SyncObserver();
	obs.register();
	setupSearchInput();
	setTimeout(listAllOBMCalendars, 100);
}

window.addEventListener("load", onLoad, false);